from tkinter import *

leftPos   = [0,0,0]     #　左マウス座標位置と線の識別番号
rightPos  = [0,0,0]     #　右マウス座標位置と線の識別番号     
middlePos = [0,0,0]     #中央マウス座標位置と線の識別番号      
lineDt=[]
root=Tk()
canvas=Canvas(root,width=500,height=500)
canvas.pack()
canvas.focus_set()
#左ボタンイベント
def leftMouseDown(event):#ダウン
    canvas.focus_set()
    x=event.x
    y=event.y
    leftPos[0]=x
    leftPos[1]=y
    leftPos[2]=canvas.create_line(x,y,x,y,fill='black',tag="Line")
    root.update()
    print("Left Button Down", x, y," Button No.",event.num)
def leftMouseMove(event):#移動
    x=event.x
    y=event.y
    canvas.delete(leftPos[2])
    leftPos[2]=canvas.create_line(leftPos[0],leftPos[1],x,y,fill='black',tag="Line")
    root.update()
def leftMouseRelease(event):#アップ
    x=event.x
    y=event.y
    lineDt.append(leftPos[2])
    print(" data =", lineDt)
    print("Left Button Release", x, y," Button No.",event.num)
def leftMouseDoubleClick(event):#ダブルクリック
    x=event.x
    y=event.y
    print("Left Button Double Click", x, y," Button No.",event.num)
#右ボタンイベント    
def rightMouseDown(event):#ダウン
    canvas.focus_set()
    x=event.x
    y=event.y
    rightPos[0]=x
    rightPos[1]=y
    rightPos[2]=canvas.create_line(x,y,x,y,fill='red',tag="Line")
    root.update()
    print("Right Button Down", x, y," Button No.",event.num)
def rightMouseMove(event):#移動
    x=event.x
    y=event.y
    canvas.delete(rightPos[2])
    rightPos[2]=canvas.create_line(rightPos[0],rightPos[1],x,y,fill='red',tag="Line")
    root.update()
def rightMouseRelease(event):#アップ
    x=event.x
    y=event.y
    print("Right Button Release", x, y," Button No.",event.num)
def rightMouseDoubleClick(event):#ダブルクリック
    x=event.x
    y=event.y
    print("Right Button Double Click", x, y," Button No.",event.num)
#中央ボタンイベント   
def middleMouseDown(event):#ダウン
    canvas.focus_set()
    x=event.x
    y=event.y
    middlePos[0]=x
    middlePos[1]=y
    middlePos[2]=canvas.create_line(x,y,x,y,fill='blue',tag="Line")
    root.update()
    print("Middle Button Double Click", x, y," Button No.",event.num)
def middleMouseMove(event):#移動
    x=event.x
    y=event.y
    canvas.delete(middlePos[2])
    middlePos[2]=canvas.create_line(middlePos[0],middlePos[1],x,y,fill='blue',tag="Line")
    root.update()
def middleMouseRelease(event):#アップ
    x=event.x
    y=event.y
    print("Middle Button Release", x, y," Button No.",event.num)
#■一般的なマウス移動
def MouseMotion(event):
    x=event.x
    y=event.y
    if isinstance(event.num,int):
        print("Mouse Move", x, y," Button No.",event.num)
    else: print("Mouse Move", x, y," Releace")
#図形上でのクリックイベント   
def deleteLine(event):
    canvas.delete('current')
    print("Line select Button No.",event.num)
#■バインドの指定
canvas.bind("<Motion>", MouseMotion)
#左ボタン
canvas.bind("<Button-1>",leftMouseDown)
canvas.bind("<B1-Motion>",leftMouseMove)
canvas.bind("<ButtonRelease-1>",leftMouseRelease)
canvas.bind("<Double-Button-1>",leftMouseDoubleClick)
#中央ボタン
canvas.bind("<Button-2>",middleMouseDown)
canvas.bind("<B2-Motion>",middleMouseMove)
canvas.bind("<ButtonRelease-2>",middleMouseRelease)
#右ボタン
canvas.bind("<Button-3>",rightMouseDown)
canvas.bind("<B3-Motion>",rightMouseMove)
canvas.bind("<ButtonRelease-3>",rightMouseRelease)
canvas.bind("<Double-Button-3>",rightMouseDoubleClick)
#タグ'Line'を持つ図形上での左ボタンクリック
canvas.tag_bind('Line',"<Button-1>", deleteLine)
#■メインループ


root.mainloop()
    

    
   
